# NAME

jquery.dabsalad - background-image slideshow

# VERSION

version 0.10

# DESCRIPTION

スライドショーも可能な背景画像表示ライブラリです。

Please see [Wicker Wings \[ja\]](http://dabsalad.wi-wi.jp/) for more information.

# Usage

- jQuery("#selector").dabSalad([options, ] images [, dressing] [, dressing ...]):
- jQuery("#selector").dabSalad([options, ] image, count [, dressing] [, dressing ...]):
  
# Arguments

## options: Object
- loop: Boolean ( true )
- imidiate: Boolean ( true )
- onstart: Function ( null )
- onchange: Function ( null )
- onend: Function ( null )

### loop
画像のスライドショーをループさせます。

### imidiate
画像読み込みが完了すると、すぐに最初のアニメーションを開始します。

### callback functions

グローバルオプションのonstart, onchange, onendにコールバック関数を指定するとそれぞれのタイミングで関数が呼び出されます。

- onstart( index )
 this: ベースとなるnode

アニメーションを開始する直前に呼び出されます。

- onchange( index )
 this: ベースとなるnode

アニメーション終了直後に呼び出されます。

- onend( index )
 this: ベースとなるnode

全ての画像のアニメーションが終了した時点で呼び出されます。
loopする場合は、ループの度に呼び出されます。


## images: Array

ファイル名の配列。

- jQuery("#selector").dabSalad(["image1.png", "image2.png", "image3.png"]);

## image: String

連番の場合は、基準となるファイル名と連番の最大数を指定することができます。

## count: Number

- jQuery("#selector").dabSalad("image.png", 3);

imageと合わせ、連番でファイル名を生成します。
ファイル名の番号は１から始まります。

１つ目の引数が文字列の場合は２つ目の引数が数値で、必須となります。

ex.)
.dabSalad( "image.png", 3 )
.dabSalad( ["image1.png", "image2.png", "image3.png"] ).

上記２種類の書き方は同等です。

## dressing: Object

指定可能なオプションは以下の通りです。

### dressing - "dressing"
デフォルトアニメーションイフェクト
- dressing: "dressing"
- rows: Number ( 1 )
- cols: Number ( 1 )
- delay: Number ( 300 )
- rowDelay: Number ( 300 )
rowDelay未指定時はdelayを適用
- colDelay: Number ( 300 )
colDelay未指定時はdelayを適用
- duration: Number ( 1000 )
- interval: Number ( 4000 )
アニメーション開始までのインターバル
- effect: Enumerated Array ( ["fade"] )
"fade", "slideleft", "slideright", "slideup", "slidedown", "wipeleft", "wiperight", "wipeup", "wipedown", "slideleftturn", "sliderightturn", "slideupturn", "slidedownturn", "wipeleftturn", "wiperightturn", "wipeupturn", "wipedownturn"
- easing: Enumerated String ( "linear" )
depends on jquery.Easing
- size: Enumerated String ( "100% 100%" )
"cover", "contain", "auto", "(length) (length)"
"auto"指定時は画像のオリジナルサイズ
- order: Enumerated String ( "down-right" )
"down-right", "down-left", "up-right", "up-left", "skip", "mountain", "valley", "random"
- color: String ( "transparent" )
"#"で始まる16進数3または6文字、rgb()、rgba()

### dressing - "image"
分割不可、移動、拡大のみ
- dressing: "image"
- delay: Number ( 1000 )
fade-in完了までの時間
- duration: Number ( 1000 )
移動、拡大完了までの時間
- interval: Number ( 4000 )
アニメーション開始までのインターバル
- fade: Boolean ( true )
- from: Object ( {top: 0, left: 0, width: 0, height: 0 } )
- to: Object ( {top: 0, left: 0, width: "100%", height: "100%" } )
- easing: Enumerated String ( "linear" )
depends on jquery.Easing
- color: String ( "transparent" )
"#"で始まる16進数3または6文字、rgb()、rgba()

### dressing - "color"
分割不可、移動、拡大のみ
- dressing: "color"
- duration: Number ( 300 )
- rows: Number | String ( 4 )
- cols: Number | String ( 4 )
- delay: Number ( 300 )
- rowDelay: Number ( 300 )
rowDelay未指定時はdelayを適用
- colDelay: Number ( 300 )
colDelay未指定時はdelayを適用
- interval: Number ( 4000 )
アニメーション開始までのインターバル
- fade: Boolean ( true )
- easing: Enumerated String ( "linear" )
depends on jquery.Easing
- order: Enumerated String ( "down-right" )
"down-right", "down-left", "up-right", "up-left", "skip", "mountain", "valley", "random"
- color: String ( "transparent" )
"#"で始まり、16進数6文字 × 色数


## effect
複数のイフェクトを指定した場合は、そのイフェクトが同時に行われます。
例）["slideleft", "slideup"]
slideleftとslideupを同時に行うため、左上に（斜めに）スライドします。

up-down、left-rightの組み合わせを同時に指定することはできません。


## dressing - presets
プリセット名を指定する事で個々の指定を省略できます。
- dressing: "rain"
{dressing: 'dressing', order:"random", effect: ["slidedown", "fade"], delay: 250, duration:1500, rows:1, cols: 20 }
- dressing: "zigzag"
{dressing: 'zigzag', order:"down-right", effect: ["sliderightturn", "fade"], duration:600, delay: 400, rows:10, cols: 1 }
- dressing: "arpeggio"
{dressing: 'dressing', order:"down-left", effect: ["wipedown", "fade"], rowDelay: 250, colDelay: 350, duration:750, rows:6, cols: 8 }
- dressing: "smash"
{dressing: 'dressing', order:"random", effect: ["slideleft"], rowDelay: 100, colDelay: 50, duration:400, rows:10, cols: 1 }
- dressing: "raise"
{dressing: 'dressing', order:"up-right", effect: ["wipeupturn"], rowDelay: 250, colDelay: 400, duration: 1000, rows:10, cols: 10 }
- dressing: "open"
{dressing: 'dressing', order:"down-right", effect: ["wiperightturn"], rowDelay: 0, colDelay: 0, duration:1000, rows:1, cols: 2 }
- dressing: "skip"
{dressing: 'dressing', order:"skip", effect: ["sliderightturn", "slidedownturn", "fade"], rowDelay: 250, colDelay: 250, duration:1000, rows:10, cols: 10 }
- dressing: "mountain"
{dressing: 'dressing', order:"mountain", effect: ["wipeup", "fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:1, cols: 9 }
- dressing: "curtain"
{dressing: 'dressing', order:"valley", effect: ["wipedown", "fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:1, cols: 9 }
- dressing: "iris"
{dressing: 'dressing', order:"mountain", effect: ["fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:9, cols: 9 }
- dressing: "random"
上記のいずれかをランダムに設定します。




# Sample code

```javascript

jQuery(document).ready(function(){

// use "r.png", "g.png", "b.png", effect is "curtaindown".
jQuery("#eyecatch").dabSalad(["r.png", "g.png", "b.png"], {dressing: "dressing", order: "down-right", effect: ["slidedown"]});

// use "r.png", "g.png", "b.png", effect is "slidedown" and "slideleft" that slide from top-left to bottom-right.
jQuery("#eyecatch").dabSalad(["r.png", "g.png", "b.png"], {effect: ["slidedown", "slideright"]});

// use "r.png", "g.png", "b.png", effect is "curtaindown" and "fade".
jQuery("#eyecatch").dabSalad(["r.png", "g.png", "b.png"], {effect: ["curtaindown", "fade"]});

// use "header1.jpg", "header2.jpg", "header3.jpg", with default option and dressing.
jQuery("header").dabSalad("header.jpg", 3);

// use "1.jpg", "2.jpg", "3.jpg", with default options
jQuery("#sample2").dabSalad(".png", 3, {loop: true});



// use colors instead of images.
jQuery("#sample").dabSalad(["#FF0000","#FF00FF","#00FF00"]);

// mix colors and images.
jQuery("#sample").dabSalad(["#FF0000","#FF00FF","g.png","b.png","#FFFF00","#0000FF","#00FF00"], {effect:['curtainleft', 'curtaindown', 'fade'], loop: true, duration:1000, delay: 1500});

// use preset "skip"
jQuery("#eyecatch").dabSalad("image.jpg", 5, {dressing: "skip"});



});
```
