/****
jquery.Dabsalad Ver. 0.10
Copyright (c) 2013 Wicker Wings
http://www.wi-wi.jp/

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
****/
;if (!Function.prototype.bind) {
  Function.prototype.bind = function (oThis) {
    if (typeof this !== "function") {
      // closest thing possible to the ECMAScript 5 internal IsCallable function
      throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");
    }

    var aArgs = Array.prototype.slice.call(arguments, 1), 
        fToBind = this, 
        fNOP = function () {},
        fBound = function () {
          return fToBind.apply(this instanceof fNOP && oThis
                                 ? this
                                 : oThis,
                               aArgs.concat(Array.prototype.slice.call(arguments)));
        };

    fNOP.prototype = this.prototype;
    fBound.prototype = new fNOP();

    return fBound;
  };
}
;(function($){

	$(function($){
	
	(function createStyleSheet(doc){
		var selectors = {
			".dab-salad": "width: 100%; height: 100%; position: absolute; top: 0; left: 0; z-index: -2; margin: 0; padding: 0; border: 0; background-repeat: repeat; background-size: auto; background-color: transparent; overflow: hidden",
			".dab-salad img": "position: absolute; top: 0px; left:0px; borderWidth:0; borderRadius:0; margin:0; padding:0;",
			".dab-salad div": "position: absolute; top: 0px; left:0px; borderWidth:0; borderRadius:0; margin:0; padding:0;",
			".dab-garnish": "background-repeat: no-repeat; z-index: -1",
			".dab-topping": "background-repeat: no-repeat; z-index: 9999"
		};
		
		if( doc.createStyleSheet ){
			var sheet = doc.createStyleSheet();
			for(var selector in selectors ){
				sheet.addRule(selector, selectors[selector]);
			}
			
		}else{
			var style =document.createElement('style');
			style.type = 'text/css';
			document.getElementsByTagName('head')[0].appendChild(style);
			if( !window.createPopup ) { /* For Safari */
				style.appendChild(document.createTextNode(''));
			}
			var sheet = style.sheet;
			var index=sheet.cssRules.length;
			for(var selector in selectors ){
				sheet.insertRule(selector + ' {'+selectors[selector]+'}', sheet.cssRules.length);
			}
			
		}
	}(document));
	
	});
	
	function makeCover(node, className){
		var $node = $(node);
		className = className || '';
		return $('<div>')
				.addClass(className)
				.css("borderTopLeftRadius", $node.css("borderTopLeftRadius"))
				.css("borderTopRightRadius", $node.css("borderTopRightRadius"))
				.css("borderBottomLeftRadius", $node.css("borderBottomLeftRadius"))
				.css("borderBottomRightRadius", $node.css("borderBottomRightRadius"))
				.css("WebkitBorderTopLeftRadius", $node.css("WebkitBorderTopLeftRadius"))
				.css("WebkitBorderTopRightRadius", $node.css("WebkitBorderTopRightRadius"))
				.css("WebkitBorderBottomLeftRadius", $node.css("WebkitBorderBottomLeftRadius"))
				.css("WebkitBorderBottomRightRadius", $node.css("WebkitBorderBottomRightRadius"))
				.css("MozBorderRadius", $node.css("MozBorderRadius"));
	}
	
	function setupNode(node){
		var $node = $(node);
		if( $node.css('position') === 'static' ){
			$node.css('position', 'relative');
		}
		$node.css({'zIndex': '0', 'backgroundColor': 'transparent', 'backgroundImage': 'none'});
	}

	// 飾り添え
	function DabGarnish(element, src, opacity, size){
		this._image = null;
		if( src && !detectColor(src) ){
			this._image = new Image();
			this._image.onload = this.resize.bind(this);
			this._image.src= src;
		}
		
		this._opacity = getDefault(opacity, 1);
		this._color = detectColor(src)? src: 'transparent';
		this._size = size;
		this._node = element;
		this._$cover = null;
		
		this.initialize();
		this._$cover.addClass('dab-garnish');
	}
	inheritClass(DabGarnish, null, {
		initialize: function(){
			
			setupNode( this._node );
			
			this._$cover = makeCover( this._node, 'dab-salad');
			this._$cover.appendTo(this._node);
			
			if( $.support.opacity ){
				if( this._image ){
					this._$cover.css({'backgroundImage':'url('+this._image.src+')'});
				}else{
					this._$cover.css({'backgroundColor': this._color});
				}
				this._$cover.css({'backgroundSize': '100% 100%',
									'MozBackgroundSize': '100% 100%',
									'webkitBackgroundSize': '100% 100%',
									'opacity': this._opacity
								});
			}else{
				this.filterIE();
			}
			
			this.resize();
			$(window).on('resize', this.resize.bind(this) );
			
		},
		resize: function(){
			if( !this._size || this._image){
				return this;
			}
			
			if( !/MSIE/.test(navigator.userAgent) || $.support.opacity ){
				this._$cover.css({'backgroundSize': this._size, 'webkitBackgroundSize': this._size, 'MozBackgroundSize': this._size});
			}else{
				var metrix = getImageMetrix(this._image, this._$cover, this._size);
				this._$cover.css({width: width+'px', height: height+'px'});
			}
			return this;
			
		},
		filterIE: function(){
			var opa = this._opacity*100;
			
			this._$cover.css({'backgroundImage': 'none',
							'backgroundColor': this._color});
			
			var value = '';
			if( opa!==100 ){
				value += 'progid:DXImageTransform.Microsoft.Alpha(opacity='+opa+'), ';
			}
			if( this._image ){
				value +="progid:DXImageTransform.Microsoft.AlphaImageLoader( src="+ this._image.src+", sizingmethod=scale )";
			}
			
			this._$cover.css('filter', value);
		}
	});
	
	// トッピング
	function DabTopping(element, src, opacity){
		DabGarnish.apply(this, arguments);
		this._$cover.addClass('dab-topping');
	}
	inheritClass(DabTopping, DabGarnish, {});
	
	function DabSalad(element, gOptions, images, options){
		this._tmIntervalID= 0;
		this._tmPreloadID= 0;
		this._options = options;
		this._images = images;
		this._node = element;
		this._$transient = null;
		this._$cover = null;
		this._platter = new Platter();
		
		this.onstart = gOptions.onstart;
		this.onend = gOptions.onend;
		this.onchange = gOptions.onchange;
		
		this._loop = gOptions.loop;
		this._imidiate = gOptions.imidiate;
		
		this.initialize();
		this.registerPlatter();
		
		this.wait4load();
	}
	
	inheritClass(DabSalad, null, {
		initialize: function(){
			setupNode( this._node );
			
			this._$cover = makeCover(this._node, 'dab-salad');
			this._$transient = this._$cover.clone();
			
			this._$cover.addClass('dab-salad-cover');
			this._$transient.addClass('dab-salad-transient');
			
		},
		
		registerPlatter: function(){
			for( var i=0, k=0, options = this._options, src, color, option; i<this._images.length; i++, k++ ){
				src = this._images[i];
				if( !options[k] ){
					k=0;
				}
				option = options[k];
				option = inherit( {dressing:'dressing', group: false}, option);
				
				
				if( k && (option.inherit===undefined || option.inherit) && (options[i-1] && options[i-1].dressing===option.dressing) ){
					option = inherit(options[i-1] || options[0] || {}, option);
				}
				
				option = inherit( {duration: 1000, interval: 4000}, option);
				
				if( detectColor(src) ){
					color = src;
					src = null;
				}else{
					color = option.color || 'transparent';
				}
			
				this._platter.add( new Ingredient(src, color, option) );
			}
		},
		
		run: function(){
			if( this.onstart ){
				this.onstart.call(this._node, this._platter.current(), this._$transient, this);
			}
			this._platter.run( this.animateEnd, this );
			return  this;
			
		},
		
		animateEnd: function(){
			this.finish();
			
			if( this.onchange ){
				this.onchange.call(this._node, this._platter.current(), this._$cover, this);
			}
			
			if( this.isLast() && this.onend ){
				this.onend.call(this._node, this._platter.current(), this._$cover, this);
			}
			
			if( !this.isLast() || this._loop ){
				this._platter.next();
				this.start();
			}
		},
		
		finish: function(){
			var $tmp = this._$cover;
			this._$cover = this._$transient;
			this._$transient = $tmp;
			
			this._platter.tidy();
			
			this._$transient.remove();
			this._$cover.css("zIndex", -3);
			
			return this;
		},
		
		start: function(){
			this.stop();
			
			if( this._platter.isMovable ){
				this._$transient = this._$cover;
				this._$cover = null;
			}
			var $transient = this._$transient;
			$transient.empty().css({'zIndex': "-2", 'opacity': '1'});
			
			$(this._node).append($transient, this._$cover);
			
			var interval = this._platter.start( $transient );
			
			if( !interval ){
				this.run();
			}else{
				this._tmIntervalID = setTimeout( this.run.bind(this), interval );
			}
			
			return this;
		},
		
		stop: function(){
			if( this._tmIntervalID ){
				this._tmIntervalID = clearInterval( this._tmIntervalID );
			}
			if( this._tmPreloadID ){
				this._tmPreloadID = clearTimeout( this._tmPreloadID );
			}
			
			this._platter.stop();
			
			return this;
		},
		
		isLast: function(){
			return this._platter.isLast();
		},
		
		next: function(){
			this.stop();
			this.finish();
			this._platter.next();
			this.start(); 
			return this;
		},
		
		play: function(id){
			var platter = this._platter;
			platter.current(id);
			this.start();
			
			return this;
		},
		
		count: function(){
			return this._platter.count();
		},
		
		wait4load: function(){
			if( this._tmPreloadID ){
				clearTimeout( this._tmPreloadID );
			}
			var sum = this._platter.count(),
				count = this._platter.isReady();
			
			if( sum === count ){
				this._$transient.css({'zIndex': "-2", 'opacity': '1'});
				$(this._node).append(this._$transient, this._$cover);
				this.start();
				if(this._tmIntervalID && this._imidiate){
					this.stop();
					this.run();
				}
				
			}else{
				this._tmPreloadID = setTimeout( this.wait4load.bind(this), 100);
				
			}
		},
		
		destroy: function(){
			this.stop();
			this._$transient.remove();
			this._$cover.remove();
		}
		
	});
	
	$.fn.dabSalad = function(images, number){
		
		var args = Array.prototype.slice.call(arguments);
		var globalOptions = {loop: true, imidiate: true, onstart: null, onend: null, onchange: null};
		if( args[0].constructor !== Array && args[0].constructor !== String ){
			globalOptions = inherit(globalOptions, args[0]);
			
			images = args[1];
			number = args[2];
			args.shift();
		}
		
		if( images.constructor === String ){
			var re = /^(.*?)(\.[^\.]+)$/,
			match = images.match( re );
			if( !match ){
				for( var i=1, ary=[]; i<=number; i++ ){
					ary[i-1] = images?images+i: '';
				}
			}else{
				for( var i=1, ary=[]; i<=number; i++ ){
					ary[i-1] = match[1] + i + match[2];
				}
			}
			images = ary;
		}
		
		var length = (typeof(number) === 'number')? 2: 1;
		var dressings = args.slice(length);
		if( !dressings.length ){
			dressings[0] = {};
		}
		
		return this.each(function(index, item){
			var $this = $(this);
			
			var old = $this.data('dabsalad');
			if( old ){
				old.destroy();
				$this.data('dabsalad', '');
				old = null;
			}
			
			$this.data('dabsalad', new DabSalad(this, globalOptions, images, dressings) );
			
			return $this;
		});
	};
	$.fn.dabGarnish = function(image, opacity, size){
		
		return this.each(function(key, value){
			var $this = $(this);
			
			var old = $this.data('dabgarnish');
			if( old ){
				old.destroy();
				$this.data('dabgarnish', '');
				old = null;
			}
			$this.data('dabgarnish', new DabGarnish(this, image, opacity, size) );
			
			return $this;
		});
	};
	
	$.fn.dabTopping = function(image, opacity, size){
		
		return this.each(function(key, value){
			var $this = $(this);
			
			var old = $this.data('dabtopping');
			if( old ){
				old.destroy();
				$this.data('dabtopping', '');
				old = null;
			}
			$this.data('dabtopping', new DabTopping(this, image, opacity, size) );
			
			return $this;
		});
	};
	
	for( var i=0, style = $('<div>')[0].style, bgsize = (style.backgroundSize!==undefined), prefs = ['webkit', 'moz', 'o', 'ms'];
			 i<prefs.length && !(bgsize);
			 i++ ){
		bgsize = ( style[prefs[i]+'BackgroundSize']!==undefined );
	}
	
	$.support.backgroundsize = $.support.backgroundsize || bgsize;

function inherit(superClass, subClass){
	for(var prop in superClass){
		if( subClass[prop] === undefined ){
			subClass[prop] = superClass[prop];
		}
	}
	return subClass;
}
	
function detectColor(s){
	return /^#[0-9A-F]{3,6}$|^rgba?\([0-9,\.\s]+?\)$/.test(s);
}

function inheritClass(subClass, superClass, proto){
	// does not copy poroperties, must do "SuperClass.apply(this, arguments);" in subClass' constructor
	if( superClass!==null ){
		for(var i in superClass)
			if(typeof(subClass[i])=='undefined')
				subClass[i]=superClass[i];
		subClass.prototype = new superClass();
	}
	subClass.prototype.constructor = subClass;
	if( proto )
		for(var i in proto)
			if( proto.hasOwnProperty(i) )
				subClass.prototype[i]=proto[i];

	return subClass;
}

function getDefault(){
	var result;
	for( var i=0; i<arguments.length; i++ ){
		result = arguments[i];
		if( result!==undefined ){
			break;
		}
	}
	return result;
}


function getImageMetrix(image, $node, sizing){
	var cWidth = $node.innerWidth(),
	cHeight = $node.innerHeight();
	var width, height;
	
	if( image ){
		var img=new Image();
		img.src=image.src;
		
		width = img.width || cWidth;
		height = img.height || cHeight;
		img = null;
	}else{
		width = cWidth;
		height = cHeight;
	}
	if( sizing == 'contain' ){
		var ratio = cHeight/height;
		width = Math.ceil(width * ratio);
		height = Math.ceil(height * ratio);
		
		if( cWidth < width ){
			ratio = Math.ceil(width/cWidth);
			width = Math.ceil(width * ratio);
			height = Math.ceil(height * ratio);
		}
		
	}else if( sizing === 'cover' ){
		var ratio = cHeight/height;
		width = Math.ceil(width * ratio);
		height = Math.ceil(height * ratio);
		
		if( width < cWidth ){
			ratio = cWidth/width;
			width = Math.ceil(width * ratio);
			height = Math.ceil(height * ratio);
		}
		
	}else{
		var ratio = sizing.split(/\s/);
		ratio[1] = ratio.length===2? ratio[1]: ratio[0];
		
		width = getResized( ratio[0], width, cWidth);
		height = getResized( ratio[1], height, cHeight);
		
	}
	return {width: width, height: height};
}

function getResized(spec, originalSize, coverSize){
	if( spec==='auto' ){
		return originalSize;
	}else if( spec.match( /(\d+?)([a-zA-Z%]+)/ ) ){
		var unit = RegExp.$2;
		if( unit === '%' ){
			return coverSize * RegExp.$1 / 100;
		}else if( unit === 'px' ){
			return +RegExp.$1;
		}
	}
	return originalSize;
}
	
	// Dressing Organizer
	var Organic = {
		_defaultItem: Dressing,
		_items: {},
		_preset: {},
		register: function(id, constructor, option){
			id = id || this.createID();
			this._items[id] = constructor;
			return this;
		},
		select: function( image, color, options ){
			options = this.preset(options);
			var id = options ? options.dressing : _defaultItem.id;
			if( this._items[id] ){
				return (new this._items[id](image, color, options));
			}
			return (new this._defaultItem(image, color, options));
		},
		createID: function(){
			var id;
			
			do{
				id = '';
				var a = "a".charCodeAt(0),
					fromCharCode = String.fromCharCode, random = Math.random;
				for( var i=0; i<10; i++ ){
					id+=fromCharCode(~~(random()*25) + a);
				}
			}while( this._items[id] );
			return id;
		},
		preset: function(options){
			if( !options ){
				return options;
			}
			switch( options.dressing ){
			case 'rain':
				options = {dressing: 'dressing', order:"random", effect: ["slidedown", "fade"], delay: 250, duration:1500, rows:1, cols: 20 };
				break;
			case 'zigzag':
				options =  {dressing: 'zigzag', order:"down-right", effect: ["sliderightturn", "fade"], duration:600, delay: 400, rows:10, cols: 1 };
				break;
			case 'arpeggio':
				options = {dressing: 'dressing', order:"down-left", effect: ["wipedown", "fade"], rowDelay: 250, colDelay: 350, duration:750, rows:6, cols: 8 };
				break;
			case 'smash':
				options = {dressing: 'dressing', order:"random", effect: ["slideleft"], rowDelay: 100, colDelay: 50, duration:400, rows:10, cols: 1 };
				break;
			case 'raise':
				options = {dressing: 'dressing', order:"up-right", effect: ["wipeupturn"], rowDelay: 250, colDelay: 400, duration: 1000, rows:10, cols: 10 };
				break;
			case 'open':
				options =  {dressing: 'dressing', order:"down-right", effect: ["wiperightturn"], rowDelay: 0, colDelay: 0, duration:1000, rows:1, cols: 2 };
				break;
			case 'skip':
				options =  {dressing: 'dressing', order:"skip", effect: ["sliderightturn", "slidedownturn", "fade"], rowDelay: 250, colDelay: 250, duration:1000, rows:10, cols: 10 };
				break;
			case 'mountain':
				options =  {dressing: 'dressing', order:"mountain", effect: ["wipeup", "fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:1, cols: 9 };
				break;
			case 'curtain':
				options =  {dressing: 'dressing', order:"valley", effect: ["wipedown", "fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:1, cols: 9 };
				break;
			case 'iris':
				options =  {dressing: 'dressing', order:"mountain", effect: ["fade"], rowDelay: 100, colDelay: 100, duration: 1000, interval: 3000, rows:9, cols: 9 };
				break;
			case 'random':
				var list = ['rain','zigzag','arpeggio','smash','raise','open','skip','mountain','curtain','iris',''];
				options = this.preset({dressing: list[ Math.floor(Math.random()*(list.length)) ]});
				options.dressing = 'random';
			}
			return options;
		}
	};
	
	// イフェクト
	function Dressing(image, color, options){
		if( arguments.length === 0 ){
			image = color = '';
			options ={};
		}
		this.id = 'dressing';
		this._container = null;
		
		this._interval = getDefault(options.interval, 4000);
		this._duration = getDefault(options.duration, 1000);
		this._easing = options.easing || 'linear';
		this._size = getDefault(options.size, '100% 100%');
		
		this._height = 0;
		this._width = 0;
		
		this._effects = options.effect || ['fade'];
		this._fade = getDefault(options.fade, $.inArray('fade', this._effects)!==-1, true);
		
		this._devide = {rows: options.rows || 1, cols: options.cols || 1};
		this._colDelay = getDefault(options.colDelay, options.delay, 300);
		this._rowDelay = getDefault(options.rowDelay, options.delay, 300);
		this._order = options.order || 'down-right';
		
		this._image = image;
		this._color = color;
		
		this.initialize();
	}
	Organic.register('dressing', Dressing);
	inheritClass(Dressing, null, {
		initialize:function(){
			
		},
		sortShuffle: function(elements){
			var result = [];
			while( elements.length ){
				n=Math.floor( Math.random()*elements.length );
				result.push( elements.splice(n,1) );
			}
			return result;
		},
		sortReverseRow: function(a, b){
			var acell = getCellPos(a);
			var bcell = getCellPos(b);
			return (acell[0]===bcell[0])? bcell[1]-acell[1]: acell[0]-bcell[0];
		},
		sortReverseCol: function(a, b){
			var acell = getCellPos(a);
			var bcell = getCellPos(b);
			return (acell[1]===bcell[1])? bcell[0]-acell[0]: bcell[1]-acell[1];
		},
		sortReverse: function(a, b){
			return getCellId(b)-getCellId(a);
		},
		sortSkip: function(a, b){
			var aid = getCellId(a),
				bid = getCellId(b);
			return aid>bid? (bid%2 ? -1: 1) : 1;
			
		},
		sortValley: function(elements, rows, cols, isCol){
			if( isCol ){
				var els = [];
				for( var i=0, k=elements.length-1, len=elements.length/2; i<len; i++, k-- ){
					els.push( elements[i] );
					if( len<=k ){
						els.push( elements[k] );
					}
				}
				elements = els;
				els = null;
				return elements;
				
			}else{
				var els = [];
				for( var i=0; i<rows; i++ ){
					var tmp = elements.slice(i*cols, i*cols+cols);
					tmp = this.sortValley( tmp, null, null, true );
					els.push(tmp);
				}
				els = this.sortValley( els, null, null, true );
				elements = Array.prototype.concat.apply([], els);
				els = null;
			}
			
			return elements;
		},
		run: function( callback, context){
			
			var _colDelay = this._colDelay;
			var _rowDelay = this._rowDelay;
			
			var _width = this._container.parent().innerWidth(),
				_height = this._container.parent().innerHeight();
			var _rows = this._devide.rows,
				_cols = this._devide.cols;
			if( (""+_cols).match(/px/) ){
				cellWidth = parseInt(_cols);
				_cols = Math.ceil(_width/cellWidth);
			}
			
			if( (""+_rows).match(/px/) ){
				cellHeight = parseInt(_rows);
				_rows = Math.ceil(_height/cellHeight);
			}

			// default: "down-right"
			var elements = $(this._container.children('img'));
			if( this._order === "down-left" ) {
				elements = elements.sort( this.sortReverseRow );
			}else if( this._order === "up-left" ) {
				elements = elements.sort( this.sortReverse );
			}else if( this._order === "up-right" ) {
				elements = elements.sort( this.sortReverse ).each(function(idx, item){setCellId(item, idx);}).sort( this.sortReverseRow );
			}else if( this._order === "skip" ) {
				elements = elements.sort( this.sortSkip );
				
			}else if( this._order === "valley" ) {
				elements = this.sortValley(elements, this._devide.rows, this._devide.cols);
				
			}else if( this._order === "mountain" ) {
				elements = this.sortValley(elements, this._devide.rows, this._devide.cols);
				for( var i=0, row=0; row<this._devide.rows; row++ ){
					for( var col=0; col<this._devide.cols; col++, i++ ){
						setCellPos(elements[i], row, col);
					}
				}
				elements = elements.sort( this.sortReverseCol );
				
			}else if( this._order === "random" ) {
				elements = this.sortShuffle(elements);
			}
			for( var row=0, $element, cellID=0, rowDelay=0, colDelay=0; row<_rows; row++ ){
				colDelay=0;
				for( var col=0; col<_cols; col++ ){
					$element = null;
					$element = $(elements[cellID]);
					if( row===_rows-1 && col===_cols-1 ){
						$element.delay(colDelay+rowDelay).css({visibility:'visible'}).animate({'opacity': 1, clip: $element.data('dabsaladDressingTo'), top:'0px', left:'0px', width:this._width+'px', height:this._height+'px'}, this._duration, this._easing, callback.bind(context));
					}else{
						$element.delay(colDelay+rowDelay).css({visibility:'visible'}).animate({'opacity': 1, clip: $element.data('dabsaladDressingTo'), top:'0px', left:'0px', width:this._width+'px', height:this._height+'px'}, this._duration, this._easing);
					}
					colDelay+=_colDelay;
					cellID++;
				}
				
				rowDelay+=_rowDelay;
			}
		},
		start: function(container){
			container.css({'opacity': 1, backgroundImage: 'none', backgroundColor: 'transparent'});
			
			var metrix = getImageMetrix(this._image, container.parent(), this._size);
			
			this._width = container.parent().innerWidth(),
			this._height = container.parent().innerHeight();
			var _width = metrix.width,
				_height = metrix.height,
				_cols = this._devide.cols,
				_rows = this._devide.rows;
			var cellWidth, cellHeight;
			
			if( (""+_cols).match(/px/) ){
				cellWidth = parseInt(_cols);
				_cols = Math.ceil(_width/cellWidth);
			}
			cellWidth = Math.floor(_width/_cols);
			
			if( (""+_rows).match(/px/) ){
				cellHeight = parseInt(_rows);
				_rows = Math.ceil(_height/cellHeight);
			}
			cellHeight = Math.floor(_height/_rows);
			var colsMargin = (cellWidth === _width/_cols)?_cols: _cols - (_width - cellWidth*_cols),
				rowsMargin = (cellHeight === _height/_rows)?_rows: _rows - (_height - cellHeight*_rows);
			
			var effects = this._effects;
			var opacity = this._fade?0:1;
			
			for( var row=0, $element; row<_rows; row++ ){
				for( var col=0; col<_cols; col++ ){
					$element = null;
					
					if( col === 0 && row && _cols !== colsMargin ){
						cellWidth--;
					}else if( col === colsMargin ){
						cellWidth++;
					}
					if( row === rowsMargin && !col){
						cellHeight++;
					}
					
					var cellID = row*_cols+col,
						cellTop = (row<rowsMargin)? cellHeight*row: (row===rowsMargin)? (cellHeight-1)*row: (cellHeight-1)*rowsMargin+cellHeight*(row-rowsMargin),
						cellLeft = (col<colsMargin)?cellWidth*col: (col===colsMargin)? (cellWidth-1)*col: (cellWidth-1)*colsMargin+cellWidth*(col-colsMargin);
						clipTo = "rect("+cellTop+"px, "+(cellLeft+cellWidth)+"px, "+(cellTop+cellHeight)+"px, "+cellLeft+"px)";
						
					var top=cellTop, right=cellLeft+cellWidth, bottom=cellTop+cellHeight, left=cellLeft,
						s_top = '0', s_left = '0';
					for( var i=0; i<effects.length; i++ ){
						switch( effects[i] ){
						case "slideup":
							s_top = cellHeight;
							top = bottom = cellTop;
							break;
						case "slidedown":
							s_top = -cellHeight;
							top = bottom = cellTop+cellHeight;
							break;
						case "slideleft":
							s_left = cellWidth;
							left = right = cellLeft;
							break;
						case "slideright":
							s_left = -cellWidth;
							left =right = cellLeft+cellWidth;
							break;
						case "wipeup":
							top = bottom = cellTop+cellHeight;
							break;
						case "wipedown":
							top = bottom = cellTop;
							break;
						case "wipeleft":
							left = right = cellLeft+cellWidth;
							break;
						case "wiperight":
							left =right = cellLeft;
							break;
						case "slideupturn":
							s_top = ((col+row)%2)? -cellHeight: cellHeight;
							top = bottom = ((col+row)%2)? cellTop+cellHeight: cellTop;
							break;
						case "slidedownturn":
							s_top = ((col+row)%2)? cellHeight: -cellHeight;
							top = bottom = ((col+row)%2)? cellTop: cellTop+cellHeight;
							break;
						case "slideleftturn":
							s_left = ((col+row)%2)? -cellWidth: cellWidth;
							left = right = ((col+row)%2)? cellLeft+cellWidth: cellLeft;
							break;
						case "sliderightturn":
							s_left = ((col+row)%2)? cellWidth: -cellWidth;
							left = right = ((col+row)%2)? cellLeft: cellLeft+cellWidth;
							break;
						case "wipeupturn":
							top = bottom = ((col+row)%2)? cellTop+cellHeight: cellTop;
							break;
						case "wipedownturn":
							top = bottom = ((col+row)%2)? cellTop: cellTop+cellHeight;
							break;
						case "wipeleftturn":
							left = right = ((col+row)%2)? cellLeft+cellWidth: cellLeft;
							break;
						case "wiperightturn":
							left =right = ((col+row)%2)? cellLeft: cellLeft+cellWidth;
							break;
						}
					}
					
					var clipFrom = "rect("+top+"px, "+right+"px, "+bottom+"px, "+left+"px)";
					$element = $('<img>').css({visibility:'hidden', top: s_top + 'px', left: s_left + 'px', width: _width+'px', height:_height+'px', opacity:opacity, clip: clipFrom, backgroundColor: this._color}).attr('src', (this._image)?this._image.src:'data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAkAAAEALAAAAAABAAEAAAICTAEAOw==');
					
					if( !row && !col ){
						$element.css({'borderTopLeftRadius': 'inherit', 'WebkitBorderTopLeftRadius': 'inherit'});
					}
					if( !row && col===_cols-1 ){
						$element.css({'borderTopRightRadius': 'inherit', 'WebkitBorderTopRightRidius': 'inherit'});
					}
					if( row===_rows-1 && !col){
						$element.css({'borderBottomLeftRadius': 'inherit', 'WebkitBorderBottomLeftRadius': 'inherit'});
					}
					if( row===_rows-1 && col===_cols-1 ){
						$element.css({'borderBottomRightRadius': 'inherit', 'WebkitBorderBottomRightRaduis': 'inherit'});
					}

					setCellId($element, cellID);
					setCellPos($element, row, col);
					setCellClipto($element, clipTo);
					container.append($element);
					
				}
			}
			
			this._container = container;
			return this;

		},
		tidy: function(){
			var metrix = getImageMetrix(this._image, this._container.parent(), this._size);
			this._container.children("img:first-child").css({visibility:'visible', opacity:1, 'clip':'auto', top:'0px', left: '0px', width:metrix.width+'px', height: metrix.height+'px', 'WebkitBorderRadius': 'inherit', 'MozBorderRadius': 'inherit', 'borderRadius': 'inherit'});
			this._container.children("img:not(:first-child)").remove();
			
		},
		stop: function(){
			if( this._container ){
				this._container.children("img").stop();
			}
		},
		destroy: function(){
			this._container.empty();
			this._container.remove();
			this._image=null;
		},
		load: function(){
		
		}
	});

	// イフェクト
	function DressingImage(image, color, options){
		if( arguments.length === 0 ){
			image = color = '';
			options ={};
		}
		this.id = 'image';
		
		this._fade = getDefault(options.fade, true);
		
		var _from = inherit({left:'0px',top:'0px',width:'0%',height:'0%'}, options.from || {});
		
		if( $.support.backgroundsize ){
			var _to = inherit({left:'0px',top:'0px',width:'100%',height:'100%'}, options.to || {});
			this._from = {backgroundPosition: _from.left + ' ' + _from.top,
						backgroundSize: _from.width+' '+_from.height, webkitBackgroundSize: _from.width+' '+_from.height, mozBackgroundSize: _from.width+' '+_from.height};
			this._to = {backgroundPosition: _to.left + ' ' + _to.top,
						backgroundSize: _to.width+' '+_to.height, webkitBackgroundSize: _to.width+' '+_to.height, mozBackgroundSize: _to.width+' '+_to.height};
			this._image = 'url('+image.src+')';
		}else{
			this._from = inherit({left:'0px',top:'0px',width:'0%',height:'0%'}, options.from || {});
			this._to = inherit({left:'0px',top:'0px',width:'100%',height:'100%'}, options.to || {});
			this._image = $('<img>').attr('src', image.src);
		}
		
		this._delay = getDefault(options.delay, 1000); // fade完了まで
		this._duration = getDefault(options.duration, 1000); //moveTo, sizeTo, scaleToまで
		this._easing = options.easing || 'swing';
		this._interval = getDefault(options.interval, 4000);
		
		this._color = color;
		
		this.initialize();
	}
	Organic.register('image', DressingImage);
	
	if( $.support.backgroundsize ){
	inheritClass(DressingImage, Dressing, {
		run: function( callback, context){
			this._container.css('visibility', 'visible');
			if( this._fade ){
				this._container.animate({opacity: 1}, {duration: this._delay, queue: false, easing: this._easing});
			}
			this._container.animate(this._to, this._duration, this._easing, callback.bind(context));
			
		},
		start: function(container){
			var css = {};
			css.opacity = ( this._fade )? 0: 1;
			css.backgroundImage = this._image;
			css.backgroundColor = this._color;
			css.backgroundRepeat = 'no-repeat';
			css.visibility = 'hidden';
			css.zIndex = -2;
			
			if( !this._container ){
				this._container = container.clone();
				this._container.addClass('dabsalad-image').appendTo(container.parent());
			}else{
				this._container.appendTo(this._container.parent());
			}
			this._container.css(css).css(this._from);
			
			return this;

		},
		tidy: function(){
			this._container.css(this._to).css({visibility:'visible', opacity:1, zIndex: -4});
		},
		stop: function(){
			if( this._container ){
				this._container.stop();
			}
		}
	});

	}else{
		inheritClass(DressingImage, Dressing, {
		run: function( callback, context){
			this._container.css('visibility', 'visible');
			this._image.css('visibility', 'visible');
			if( this._fade ){
				this._image.animate({opacity: 1}, {duration: this._delay, queue: false, easing: this._easing});
			}
			this._image.animate(this._to, this._duration, this._easing, callback.bind(context));
			
		},
		start: function(container){
			
			if( !this._fade ){//for IE6
				this._delay=1;
				this._fade=true;
			}
			var css = {};
			css.backgroundImage = 'none';
			css.backgroundColor = this._color;
			css.visibility = 'hidden';
			css.zIndex = -2;
			
			if( !this._container ){
				this._container = container.clone();
				this._container.addClass('dabsalad-image').appendTo(container.parent());
				this._container.append(this._image);
			}else{
				this._container.appendTo(this._container.parent());
			}
			this._container.css(css);
			this._image.css(this._from).css('opacity', 0);
			
			return this;
		},
		tidy: function(){
			this._image.css(this._to).css('opacity', 1);
			this._container.css({visibility:'visible', zIndex: -4});
		},
		stop: function(){
			if( this._image ){
				this._image.stop();
			}
		}
	});

	}// if( background-sizeサポート)
	
	// イフェクト
	function DressingColor(image, color, options){
		if( arguments.length === 0 ){
			color = 'pastel';
			options ={};
		}
		this.id = 'color';
		this._fade = getDefault(options.fade, true);
		this._duration = getDefault(options.duration, 300);
		this._colDelay = getDefault(options.colDelay, options.delay, 300);
		this._rowDelay = getDefault(options.rowDelay, options.delay, 300);
		
		this._border = getDefault(options.border,  getDefault(options._borderWidth, '8px')+' '+getDefault(options.borderStyle, 'outset')+' '+getDefault(options.borderColor, '#EEE') );
		this._borderWidth = parseInt(this._border);
		
		this._devide = {rows: options.rows || 4, cols: options.cols || 4 };
		this._easing = options.easing || 'linear';
		
		this._color = options.color || color || 'pastel';
		
		this._height = 0;
		this._width = 0;
		
		this._order = options.order || 'down-right';
		this._targetOpacity = 1;
		
		this.initialize();
	}
	Organic.register('color', DressingColor);
	inheritClass(DressingColor, Dressing, {
		initialize: function(){},
		getColor: function(id){
			id=id||this._color;
			var colors = (id==='pastel')? "FFFFFFFEEEF4FEE5D7FFE7C8FFF8E6FFF3CEFFD98EE8ADACE0C8D7F3FAFDDEF1F8DDE1F0DAEAD0EEF2C9E5E1E2DBE0E0E4E5D9B7BCBE":
				(id==='vivid')? "FFFFFFFFFF0000FFFFFF00FFFF00000000FF00FF00000000":
				(id==='monotone')? "FFFFFFEEEEEEDDDDDDCCCCCCBBBBBBAAAAAA999999888888777777666666555555444444333333222222111111000000":
				(id==='black')? '000000':
				(id.substring(0,1)==="#")? id.substring(1):
				'FFFFFF';
			return '#'+colors.substr( ~~(Math.random()*colors.length/6)*6, 6);
		},
		
		run: function( callback, context){
			
			var _colDelay = this._colDelay;
			var _rowDelay = this._rowDelay;
			
			var _width = this._container.parent().innerWidth(),
				_height = this._container.parent().innerHeight();
			var _rows = this._devide.rows,
				_cols = this._devide.cols;
			if( (""+_cols).match(/px/) ){
				cellWidth = parseInt(_cols);
				_cols = Math.ceil(_width/cellWidth);
			}
			
			if( (""+_rows).match(/px/) ){
				cellHeight = parseInt(_rows);
				_rows = Math.ceil(_height/cellHeight);
			}
			
			this._container.css('visibility', 'visible');
			
			// default: "down-right"
			var elements = $(this._container.children('div'));
			if( this._order === "down-left" ) {
				elements = elements.sort( this.sortReverseRow );
			}else if( this._order === "up-left" ) {
				elements = elements.sort( this.sortReverse );
			}else if( this._order === "up-right" ) {
				elements = elements.sort( this.sortReverse ).each(function(idx, item){setCellId(item, idx);}).sort( this.sortReverseRow );
			}else if( this._order === "skip" ) {
				elements = elements.sort( this.sortSkip );
			}else if( this._order === "valley" ) {
				elements = this.sortValley(elements, this._devide.rows, this._devide.cols);
				
			}else if( this._order === "mountain" ) {
				elements = this.sortValley(elements, this._devide.rows, this._devide.cols);
				for( var i=0, row=0; row<this._devide.rows; row++ ){
					for( var col=0; col<this._devide.cols; col++, i++ ){
						$(elements[i]).data('dabsaladDressingCell',row+' '+col)
					}
				}
				elements = elements.sort( this.sortReverseCol );
			}else if( this._order === "random" ) {
				elements = this.sortShuffle(elements);
			}
			for( var row=0, $elment, cellID=0, rowDelay=0, colDelay=0; row<_rows; row++ ){
				colDelay=0;
				for( var col=0; col<_cols; col++ ){
					$element = $(elements[cellID]);
					
					if( row===_rows-1 && col===_cols-1 ){
						$element.delay(colDelay+rowDelay).animate({'opacity': 1}, this._duration, this._easing, callback.bind(context));
					}else{
						$element.delay(colDelay+rowDelay).animate({'opacity': 1}, this._duration, this._easing);
					}
					colDelay+=_colDelay;
					cellID++;
					
				}
				
				rowDelay+=_rowDelay;
				
			}
		},
		start: function(container){
			container.css({visibility:'hidden', 'opacity': 1, backgroundImage: 'none', backgroundColor: 'transparent'});
			
			var _width = this._width = container.parent().innerWidth(),
				_height = this._height = container.parent().innerHeight(),
				_cols = this._devide.cols,
				_rows = this._devide.rows;
			
			var cellWidth, cellHeight;
			
			if( (""+_cols).match(/px/) ){
				cellWidth = parseInt(_cols);
				_cols = Math.ceil(_width/cellWidth);
			}
			cellWidth = Math.floor(_width/_cols);
			
			
			if( (""+_rows).match(/px/) ){
				cellHeight = parseInt(_rows);
				_rows = Math.ceil(_height/cellHeight);
			}
			cellHeight = Math.floor(_height/_rows);
			
			
			var colsMargin = (cellWidth === _width/_cols)?_cols: _cols - (_width - cellWidth*_cols);
			var rowsMargin = (cellHeight === _height/_rows)?_rows: _rows - (_height - cellHeight*_rows);
				
			var borderWidth = (cellWidth < this._borderWidth * 2 || cellHeight < this._borderWidth * 2 )? 0: (cellWidth < this._borderWidth * 3 || cellHeight < this._borderWidth * 3 )? Math.floor(this._borderWidth/2): this._borderWidth;
			var border = this._border.replace(/^\d+/, borderWidth);
			
			var effects = this._effects;
			var opacity = this._fade?0:1;
			
			var _color = '';
			for( var row=0, $element, cellID=0; row<_rows; row++ ){
				for( var col=0; col<_cols; col++ ){
					$element = null;
					
					color = this.getColor();
					
					if( col === 0 && row && _cols !== colsMargin){
						cellWidth--;
					}else if( col === colsMargin ){
						cellWidth++;
					}
					if( row === rowsMargin && !col){
						cellHeight++;
					}
					
					var cellContentWidth = cellWidth - borderWidth*2,
						cellContentHeight = cellHeight - borderWidth*2,
						cellTop = (row<rowsMargin)? cellHeight*row: (row===rowsMargin)? (cellHeight-1)*row: (cellHeight-1)*rowsMargin+cellHeight*(row-rowsMargin),
						cellLeft = (col<colsMargin)?cellWidth*col: (col===colsMargin)? (cellWidth-1)*col: (cellWidth-1)*colsMargin+cellWidth*(col-colsMargin);

					$element = $('<div>').css({backgroundColor: color, top: cellTop, left: cellLeft, width: cellContentWidth+'px', height:cellContentHeight+'px', opacity:opacity, border: border});


					if( !row && !col ){
						$element.css({'borderTopLeftRadius': 'inherit', 'WebkitBorderTopLeftRadius': 'inherit'});
					}
					if( !row && col===_cols-1 ){
						$element.css({'borderTopRightRadius': 'inherit', 'WebkitBorderTopRightRidius': 'inherit'});
					}
					if( row===_rows-1 && !col){
						$element.css({'borderBottomLeftRadius': 'inherit', 'WebkitBorderBottomLeftRadius': 'inherit'});
					}
					if( row===_rows-1 && col===_cols-1 ){
						$element.css({'borderBottomRightRadius': 'inherit', 'WebkitBorderBottomRightRaduis': 'inherit'});
					}

					setCellId($element, cellID);
					setCellPos($element, row, col);

					container.append($element);
					
					cellID++;
				}
			}
			
			this._container = container;
			return this;

		},
		animateRemove: function(){
			this._targetOpacity = 0;
			this.run();
		},
		tidy: function(){
			this._targetOpacity = 1;
		},
		stop: function(){
			if( this._container ){
				this._container.children("div").stop();
			}
		}
	});


	function getCellPos(cell){
		return $(cell).data('dabsaladDressingCell').split(' ');
	}
	function setCellPos(cell, row, col){
		$(cell).data('dabsaladDressingCell', row+' '+col);
	}
	function getCellId(cell){
		return $(cell).data('dabsaladDressingId');
	}
	function setCellId(cell, id){
		$(cell).data('dabsaladDressingId', id);
	}
	function getCellClipto(cell){
		return $(cell).data('dabsaladDressingTo');
	}
	function setCellClipto(cell, to){
		$(cell).data('dabsaladDressingTo', to);
	}

	// アイテム管理パターン
	function Platter(){
		this._items = [];
		this._cur = 0;
	}
	
	Platter.prototype = {
		initialize: function(){
			
			return this;
		},
		
		run: function( callback, context ){
			var cur = this.current();
			var ing = this._items[cur];
			ing.run(callback, context);
			return this;
		},
		start: function(container){
			var cur = this._cur;
			var ing = this._items[cur];
			ing.start(container);
			
			if( ing.isGroup() ){
				var c = cur;
				while( ++c < this.count() ){
					var gpIng = this._items[c];
					gpIng.start(container);
					var interval = gpIng.getInterval();
					setTimeout( gpIng.run.bind(gpIng, gpIng.tidy, gpIng), interval);
					
					if( !gpIng.isGroup() ){
						break;
					}
				}
			}
			
			return ing.getInterval();
		},
		stop: function(){
			this._items[this._cur].stop();
			return this;
		},
		
		tidy: function(){
			var cur = this.current();
			this._items[cur].tidy();
			
			var lastID = this.count() -1;
			while( this._items[cur].isGroup() && cur < lastID ){
				cur++;
			}
			this._cur = cur;
			
			return this;
		},
		
		next: function(){
			this.current( this.current()+1 );
			return this;
		},
		prev: function(){
			this.current( this.current()-1 );
			return this;
		},
		play: function(id){
			this.stop();
			this.current(id);
			this.start();
			return this;
		},
		
		add: function(item){
			this._items[this._items.length]=item;
			return this;
		},
		count: function(){
			return this._items.length;
		},
		current: function(id){
			if( id===undefined ){
				return this._cur;
			}else{
				var c = this.count();
				while( id < 0 ){
					id = id + c;
				}
				while( c <= id ){
					id = id - c;
				}
				
				this._cur = id;
				return this;
			}
		},
		isLast: function(){
			return this._cur === this.count() - 1;
		},
		countImage: function(){
			var count = 0;
			for( var i=0; i<this._items.length; i++ ){
				count += Number(this._items[i].isImage());
			}
			return count;
		},
		isReady: function(){
			var count = 0;
			for( var i=0; i<this._items.length; i++ ){
				count += Number(this._items[i].isReady());
			}
			return count;
		},
		destroy: function(){
			
			
		}
	};
	
	// 画像アイテム
	function Ingredient(src, color, options){
		this._image = null;
		this._color = color || 'transparent';
		this._duration = options.duration;
		this._pole = [0, 0];
		this._dressing = null;
		this._options = options;
		this._interval = getDefault(options.interval, 4000);
		this._complete = true;
		if( src ){
			this._complete = false;
			this._image = new Image();
			this._dabComplete = false;
			this._image.onload = this._image.onerror = this._image.onabort = (function(){
				this._complete = true;
			}).bind(this);
			this._image.src = src;
		}
		
		this.initialize();
	}
	Ingredient.prototype = {
		initialize: function(){
			this._dressing = Organic.select( this._image, this._color, this._options );
		},
		
		// アニメーション開始
		run: function(callback, context){
			this._dressing.run(callback, context);
		},
		
		// アニメーション準備、要素を生成
		start: function(container){
			this._dressing.start(container);
		},
		stop: function(){
			this._dressing.stop(true, true);
		},
		
		
		// interval
		getInterval: function(){
			return this._interval;
			
		},
		
		// アニメーションに使用したElementを削除
		tidy: function(container){
			this._dressing.tidy(container);
			
			if( this._options.dressing === 'random' ){
				this._dressing = Organic.select( this._image, this._color, this._options );
			}
		},
		
		// interval
		isGroup: function(){
			return this._options.group;
			
		},
		
		destroy: function(){
		
		
		},
		
		load: function(){
		
		},
		
		isReady: function(){
			return this._complete;
		},
		
		isImage: function(){
			return !!this._image;
		}
		
	};
	
}(jQuery));
